/*******************************************************************************
Copyright 2016 Microchip Technology Inc. (www.microchip.com)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

To request to license the code under the MLA license (www.microchip.com/mla_license), 
please contact mla_licensing@microchip.com
*******************************************************************************/

/** INCLUDES *******************************************************/
#include "system.h"

#include "app_device_cdc_basic.h"
#include "app_led_usb_status.h"

#include "usb.h"
#include "usb_device.h"
#include "usb_device_cdc.h"

/********************************************************************
 * Function:        void main(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        Main program entry point.
 *
 * Note:            None
 *******************************************************************/

/*--------------------HENKAN-----------------------*/
void    henkan_10_6keta(unsigned long data)
{
unsigned char n0,n1,n2,n3,n4,n5;

	n0=(unsigned char)(data%10);data=(data-n0)/10;
	n1=(unsigned char)(data%10);data=(data-n1)/10;
	n2=(unsigned char)(data%10);data=(data-n2)/10;
	n3=(unsigned char)(data%10);data=(data-n3)/10;
    n4=(unsigned char)(data%10);data=(data-n4)/10;
    n5=(unsigned char)(data%10);
    
    suji[0]=n0;
    suji[1]=n1;
    suji[2]=n2;
    suji[3]=n3;
    suji[4]=n4;
    suji[5]=n5;
    
}
void    henkan_10_4keta(unsigned int data)
{
unsigned char n0,n1,n2,n3;

	n0=(unsigned char)(data%10);data=(data-n0)/10;
	n1=(unsigned char)(data%10);data=(data-n1)/10;
	n2=(unsigned char)(data%10);data=(data-n2)/10;
	n3=(unsigned char)(data%10);
    
    suji[0]=n0;
    suji[1]=n1;
    suji[2]=n2;
    suji[3]=n3;
    
}

/*--------------------CLEAR-----------------------*/
void    rx_data_clear(void)
{
    rx_data[0]=0;
    rx_data[1]=0;
    rx_data[2]=0;
    rx_data[3]=0;
    rx_data[4]=0;
}

/*-------------------JUSIN HENKAN-----------------*/
void    jusin_henkan(void)
{
    
    hz_no=(unsigned long)rx_data[4]*256*256+(unsigned long)rx_data[3]*256+(unsigned long)rx_data[2];
    level_no=(unsigned int)rx_data[1]*256+(unsigned int)rx_data[0];
    
    henkan_10_6keta(hz_no);
    moji[0]=suji[5]+0x30;
    moji[1]=suji[4]+0x30;
    moji[2]=suji[3]+0x30;
    moji[3]=suji[2]+0x30;
    moji[4]=suji[1]+0x30;
    moji[5]=suji[0]+0x30;
    moji[6]=0x2c;        /*,*/
    
    henkan_10_4keta(level_no);
    moji[7]=suji[3]+0x30;
    moji[8]=suji[2]+0x30;
    moji[9]=suji[1]+0x30;
    moji[10]=suji[0]+0x30;
    
    moji[11]=0x0d;      /*CR*/
    moji[12]=0x0a;      /*LF*/
    
}

MAIN_RETURN main(void)
{
    SYSTEM_Initialize(SYSTEM_STATE_USB_START);

    USBDeviceInit();
    USBDeviceAttach();
    
    receive_flg=0;
    rx_count=0;
    rx_byte=0;
    
    hz_no=0;
    level_no=0;
    
    rx_data_clear();
    loop_count=0;
    rx_flg=0;
    
    while(1)
    {
        SYSTEM_Tasks();

        #if defined(USB_POLLING)
            // Interrupt or polling method.  If using polling, must call
            // this function periodically.  This function will take care
            // of processing and responding to SETUP transactions
            // (such as during the enumeration process when you first
            // plug in).  USB hosts require that USB devices should accept
            // and process SETUP packets in a timely fashion.  Therefore,
            // when using polling, this function should be called
            // regularly (such as once every 1.8ms or faster** [see
            // inline code comments in usb_device.c for explanation when
            // "or faster" applies])  In most cases, the USBDeviceTasks()
            // function does not take very long to execute (ex: <100
            // instruction cycles) before it returns.
            USBDeviceTasks();
        #endif

        //Application specific tasks
        
            if(receive_flg==1){
                receive_flg=0;
                jusin_henkan();
                rx_flg=1;
                rx_data_clear();
            }
            NOP();
            if(loop_count>0){
                loop_count++;
                if(loop_count>=1000){
                    rx_count=0;
                    rx_byte=0;
                    rx_data_clear();
                    loop_count=0;
                }
            }
            
        APP_DeviceCDCBasicDemoTasks();

    }//end while
}//end main

/*******************************************************************************
 End of File
*/
